#ifndef _SYS_SOCKET_HH_
#define _SYS_SOCKET_HH_

#include <netinet/in.h>
#include "net_address.hh"
#include "sys_address.hh"

extern "C++" class SYS_Address;

#define SYS_SOCKET_STATUS_NO_SOCKET    0
#define SYS_SOCKET_STATUS_NOT_BINDED   1
#define SYS_SOCKET_STATUS_OK           2

class SYS_Socket 
{
private:
  int  status;
protected:
  int  s;
public:
  SYS_Socket();
  ~SYS_Socket();
  int Bind(SYS_Address&);
  int Status();
  //int FileDescriptor();
};

class SYS_Send_Socket : public virtual SYS_Socket
{
protected:
  //SYS_Send_Socket();
public:
  //SYS_Send_Socket(SYS_Address&);
  SYS_Send_Socket();
  ~SYS_Send_Socket();
  int Send(SYS_Address&,void*,int);
  int Send(SYS_Address&,void**,int*,int);
  int SetSendBufferSize(int);
  int GetSendBufferSize();
};

#define SYS_RECEIVE_SOCKET_OPTIONS_ASYNC    0x0001
#define SYS_RECEIVE_SOCKET_OPTIONS_SYNC     0x0002
#define SYS_RECEIVE_SOCKET_OPTIONS_OWNED    0x0010

class SYS_Receive_Socket : public virtual SYS_Socket
{
private:
  int packets2;
  int options;
protected:
  //SYS_Receive_Socket();
public:
  //SYS_Receive_Socket(SYS_Address&);
  SYS_Receive_Socket();
  ~SYS_Receive_Socket();
  int SetOwn();
  int SetAsyncronousMode();
  int SetSyncronousMode();  
  int SetReceiveBufferSize(int);
  int GetReceiveBufferSize();
  int HaveData();
  int Receive(void*,int);
  int gpackets;
};

class SYS_Send_Receive_Socket :
//public virtual SYS_Socket, 
public SYS_Receive_Socket,
public SYS_Send_Socket
{
public:
  //SYS_Send_Receive_Socket(SYS_Address&);
  SYS_Send_Receive_Socket();
  ~SYS_Send_Receive_Socket();
};

#endif

